{*******************************************************************************
 *                             Rechner Version 1.3                             *
 *                 (c) 2001 Ulrich Borghoff Gymnasium Wilnsdorf                *
 *                           eMail: sum-delphi@web.de                          *
 *                                                                             *
 * Diese Rechner Version luft auf allen Delphi Versionen ab 4.0               *
 * Ein hnliches Modul fr ltere Versionen ist ebenfalls erhltlich,          *
 * allerdings sind hier einige Anfragen nicht kontextsensitiv.                 *
 *                                                                             *
 * Bitte ndern Sie diese Datei nicht ab, sondern teilen mir Verbesserungsvor- *
 * schlge oder Fehler (und ggf. deren Berichtigung) mit.                      *
 *                                                                             *
 * Fr den Unterricht sollten Sie nur die mRechner.dcu Datei verwenden. Diese  *
 * muss sich im Ordner ..delphi/lib befinden. Die Angabe "uses mRechner" ist   *
 * dann schon ausreichend.                                                     *
 *                                                                             *
 * Danke fr Ihre Mitarbeit.                                                   *
 *******************************************************************************}

unit mRechner;

interface

uses mSuM,winprocs;

type Rechner=class

constructor init;
function zufallszahl:Zahl;
function ganzeZufallszahl(pVon,pBis:GanzeZahl):GanzeZahl;
function betrag(pZahl:Zahl) : Zahl; overload;
function betrag(pZahl:GanzeZahl) : GanzeZahl; overload;
function quadrat(pZahl:Zahl):Zahl; overload;
function quadrat(pZahl:GanzeZahl):GanzeZahl; overload;
function wurzel(pZahl:Zahl):Zahl;
function potenz(pBasis,pExponent:Zahl):Zahl; overload;
function potenz(pBasis,pExponent:GanzeZahl):GanzeZahl; overload;
function rund(pZahl:Zahl):GanzeZahl;
function ganzerAnteil(pZahl:Zahl):GanzeZahl;
function zeichenVon(pOrdinalzahl:integer):char;
function ordinalZahl(pZeichen:char):integer;
destructor gibFrei;
end;

implementation

constructor Rechner.init;
begin
  randomize;
end;

function Rechner.zufallszahl : Zahl;
begin
  result:=random;
end;

function Rechner.GanzeZufallszahl(pVon,pBis:GanzeZahl) : GanzeZahl;
begin
  result:=random(pBis-pVon+1)+pVon;
end;

function Rechner.betrag(pZahl:Zahl) : Zahl;
begin
  result:=abs(pZahl);
end;

function Rechner.betrag(pZahl:GanzeZahl) : GanzeZahl;
begin
  result:=abs(pZahl);
end;

function Rechner.quadrat(pZahl:Zahl) : Zahl;
begin
  result:=sqr(pZahl);
end;

function Rechner.quadrat(pZahl:GanzeZahl) : GanzeZahl;
begin
  result:=sqr(pZahl);
end;

function Rechner.wurzel(pZahl:Zahl) : Zahl;
begin
  if pZahl<0 then
    begin
      FatalAppExit(0,'Wurzel aus einer negativen Zahl.');
      result:=0;
    end
  else result:=sqrt(pZahl);
end;

function Rechner.potenz(pBasis,pExponent:Zahl) : Zahl;
begin
  result:=exp(ln(pBasis)*pExponent);
end;

function Rechner.potenz(pBasis,pExponent:GanzeZahl) : GanzeZahl;
begin
  if (pBasis>=0) or (pExponent mod 2=0)
  then result:=round(exp(ln(abs(pBasis))*pExponent))
  else result:=-round(exp(ln(abs(pBasis))*pExponent))
end;

function Rechner.rund(pZahl:Zahl):GanzeZahl;
begin
  result:=round(pZahl);
end;

function Rechner.ganzerAnteil(pZahl:Zahl):GanzeZahl;
begin
  result:=trunc(pZahl);
end;

function Rechner.zeichenVon(pOrdinalzahl:integer):char;
begin
  result:=chr(pOrdinalzahl);
end;

function Rechner.ordinalZahl(pZeichen:char):integer;
begin
  result:=ord(pZeichen);
end;

destructor Rechner.gibFrei;
begin
end;

end.

